<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsdocman3 extends JPlugin
{
	function plgAnalyticsdocman3( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'docman3' ) return;
		
		$data = array( 'amline', 'ampie', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, $params, &$errors)
	{
			
		if($name != 'docman3') return;

		$type = $params->get('chart_type');

		if( !JComponentHelper::isEnabled('com_docman', true) ) {
			$errors = '<h3>DOCman Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");	
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows relationship documents by categories]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Relationship documents by categories</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows progress documents by categories]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Progress documents by categories</b>]]>",90 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'docman3' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}
		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'docman3') return;

		$type = $params->get('chart_type');
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(dl.log_datetime)",
			                      "sweek"  => "WEEKOFYEAR(dl.log_datetime)",
			                      "smonth" => "MONTH(dl.log_datetime)",
			                      "syear"  => "YEAR(dl.log_datetime)");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT( dl.log_datetime, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( dl.log_datetime - INTERVAL WEEKDAY(dl.log_datetime) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( dl.log_datetime, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( dl.log_datetime, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(dl.log_datetime) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		$sql = "     SELECT Count(d.id)  AS amount, d.dmname AS name,  d.id"
		.$sql_dates
		."\n  FROM      #__docman   AS d"
		."\n  INNER JOIN #__docman_log AS dl ON dl.log_docid = d.id"
		."\n  INNER JOIN #__categories AS c ON d.catid = c.id"
		."\n      WHERE c.id IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
		$sql .= " GROUP BY ".$sql_group." d.id"
		."\n   ORDER BY amount DESC"
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		if ( $type != 'ampie')
		{
			$current_date = $from;

			switch ( $groupby ) {
				case "sday":
					$format_series = '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie = strftime( $format_series, strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
					if ( $type == 'amline')
					{
						foreach( $graphs as $key => $graph) {
							if( !isset($graphs[$key][$current_date]) ) {
								$graphs[$key][$current_date] = " 0 ";
							}
						}
					}
					$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			foreach( $graphs as $key => $graph ) {
				$objChart->addGraph($key, $key, $graph, array( 
					'balloon_text' => '<![CDATA[<b>{value}</b><i>resord(s)</i> {series}]]>'
				));
			} 
		} else {
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$i = 0;
			foreach ( $slices AS $k => $slice ) {
	
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'docman3') return;

		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );
		$sort_by = $params->get('sort_by', 'amount DESC');
		$limit = $params->get('limit', 0);

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(dl.log_datetime)",
			                      "sweek"  => "WEEKOFYEAR(dl.log_datetime)",
			                      "smonth" => "MONTH(dl.log_datetime)",
			                      "syear"  => "YEAR(dl.log_datetime)");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT(dl.log_datetime, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( dl.log_datetime - INTERVAL WEEKDAY(dl.log_datetime) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( dl.log_datetime, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( dl.log_datetime, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(dl.log_datetime) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		$sql = "     SELECT Count(d.id)  AS amount, d.dmname AS name,  d.id"
		.$sql_dates
		."\n  FROM      #__docman   AS d"
		."\n  INNER JOIN #__docman_log AS dl ON dl.log_docid = d.id"
		."\n  INNER JOIN #__categories AS c ON d.catid = c.id"
		."\n      WHERE c.id IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
		$sql .= " GROUP BY ".$sql_group." d.id"
		."\n   ORDER BY ".$sort_by
		;
		
		if ( $limit )
			$sql .= " LIMIT 0, $limit";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		if ( $type != 'ampie')
		{
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
	
			$k     = 0;
			$total = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			foreach( $graphs as $key => $graph) {
				$out[] = '<th class="title">'.$key.'</th>';
			}
			$out[] = '<th width="1%">'.JText::_('Date').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			$current_date = $from;
				
			switch ( $groupby ) {
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
			}
	
			$i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to )) {
				$i++;
				if ( $limit && $i > $limit ) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = 0;
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
						$graphs[$key]['count'] = 0;
					}
	
					if( $graphs[$key][$current_date] > 0 ) {
						$graphs[$key]['total'] += $graphs[$key][$current_date];
						$graphs[$key]['count'] ++;
					}
	
					$out[] = "<td>".$graphs[$key][$current_date]."</td>";
	
				}
	
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
	
			$out[] = "<tr class='row".$k."'><td><big><b>".JText::_('Total')."</b></big></td>";
	
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".round( $graphs[$key]['total'], 2 )."<b></big></td>";
			}
			$out[] = "<td></td></tr>";
		} else {
			$k                  = 0;
			$current_total      = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			$out[] = '<th class="title">'.JText::_('Category').'</th>';
			$out[] = '<th width="1%">'.JText::_('downloads').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$k = 1;
			$i = 1;
			foreach ( $slices AS $key => $slice )
			{
				$current_total += $slice;
				$k = 1 - $k;
	
				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>", $k, $i, $key, $slice);
				$i++;
			}
			$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );
		}


		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}

	}

	function onGetTotals($name, $params)
	{
		if($name != 'docman3') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		$sql = "     SELECT Count(dl.id) AS amount, Count(distinct dl.log_docid) AS rec_count"
		."\n  FROM      #__docman_log AS dl
		Inner Join #__docman AS d ON d.id = dl.log_docid
		Inner Join #__categories AS c ON c.id = d.catid"
		."\n      WHERE c.id IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
			
		$sql_total = "     SELECT Count(d.id) AS rec_tot, sum(d.dmcounter) AS amount_tot 
		FROM #__docman AS d WHERE d.published =  1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql_total .= " AND d.dmsubmitedby = '$user_id'";

		$db->setQuery( $sql );
		$result = $db->loadObject();
		if( !$result->amount ) return;
		
		$db->setQuery( $sql_total );
		$dbtotal_records = $db->loadObject();
		
		$totals = array();
		$text = JText::_('downloads');

		$totals[0]['value'] = $dbtotal_records->rec_tot.' <i>'.JText::_( 'document(s)').'</i>';
		$totals[0]['text'] = JText::_('Total in DB');
		
		$totals[1]['value'] = $result->rec_count.' <i><b>'.JText::_( 'current document(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->rec_count * 100 / $dbtotal_records->rec_tot, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $dbtotal_records->amount_tot;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $dbtotal_records->amount_tot, 1).'% '.JText::_('of all').' '.$text;
		
		return $totals;
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>