<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsdocman4 extends JPlugin
{
	function plgAnalyticsdocman4( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'docman4' ) return;
		
		$data = array( 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
			
		if($name != 'docman4') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_docman', true) ) {
			$errors = '<h3>DOCman Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('column.data_labels','<![CDATA[{value}]]>');
		$objChart->addLabel("<![CDATA[<b>Top documents by categories</b>]]>",15 ,25 , array('text_size' => 16));
		
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'docman4' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{

		if($name != 'docman4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$max       = $params->get( 'max', 20 );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$reverse   = $params->get( 'reverse', 'DESC' );

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		$sql = "     SELECT COUNT(dl.id) AS amount, d.dmname AS title, d.id"
		."\n  FROM #__docman AS d
			INNER Join #__docman_log AS dl ON d.id = dl.log_docid"
		."\n      WHERE d.catid IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
		$sql .= " GROUP BY d.id"
		."\n   ORDER BY amount ".$reverse
		."\n      LIMIT 0, ".$max
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		foreach ( $result AS $row ) {
				$objChart->addSerie($row->id,$row->title);
				$objChart->addGraph($row->id, $row->title, array($row->id => $row->amount), array( 
						'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
					));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'docman4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$max       = $params->get( 'max', 20 );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$reverse   = $params->get( 'reverse', 'DESC' );
		$limit = $params->get('limit', 0);

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		$sql = "     SELECT COUNT(dl.id) AS amount, d.dmname AS title, d.id"
		."\n  FROM #__docman AS d
			INNER Join #__docman_log AS dl ON d.id = dl.log_docid"
		."\n      WHERE d.catid IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
		$sql .= " GROUP BY d.id"
		."\n   ORDER BY amount ".$reverse
		;
		$sql .= "    LIMIT 0, ".( $limit ? $limit : $max) ; 

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;


		$k                  = 0;
		$current_total      = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Document').'</th>';
		$out[] = '<th width="1%">'.JText::_('downloads').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $row ) {
			$slices[$row->id]['name'] = $row->title;
			$slices[$row->id]['amount'] = $row->amount;
		}

		$k = 1;
		$i = 1;
		foreach ( $slices AS $key => $slice ) {

			$current_total += $slice['amount'];

			$k = 1 - $k;

			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $i, $slice['name'], $slice['amount']
			);
			$i++;
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}

	}
	
	function onGetTotals($name, $params)
		
	{
		if($name != 'docman4') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$category  = $params->get( 'category' );
		$max       = $params->get( 'max', 20 );
		$from      = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to        = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$reverse   = $params->get( 'reverse', 'DESC' );
		$limit = $params->get('limit', 0);

		if ( !$category ) return;

		if( !is_array( $category ) ) {
			$category = array( $category );
		}

		$sql = "     SELECT Count(dl.id) AS amount, Count(distinct dl.log_docid) AS rec_count"
		."\n  FROM      #__docman_log AS dl
		Inner Join #__docman AS d ON d.id = dl.log_docid
		Inner Join #__categories AS c ON c.id = d.catid"
		."\n      WHERE c.id IN('".implode( "', '", $category )."') AND dl.log_datetime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND d.dmsubmitedby = '$user_id'";
			
		$sql_total = "     SELECT Count(d.id) AS rec_tot, sum(d.dmcounter) AS amount_tot 
		FROM #__docman AS d WHERE d.published =  1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql_total .= " AND d.dmsubmitedby = '$user_id'";

		$db->setQuery( $sql );
		$result = $db->loadObject();
		if( !$result->amount ) return;
		
		$db->setQuery( $sql_total );
		$dbtotal_records = $db->loadObject();
		
		$totals = array();
		$text = JText::_('downloads');

		$totals[0]['value'] = $dbtotal_records->rec_tot.' <i>'.JText::_( 'document(s)').'</i>';
		$totals[0]['text'] = JText::_('Total in DB');
		
		$totals[1]['value'] = $result->rec_count.' <i><b>'.JText::_( 'current document(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->rec_count * 100 / $dbtotal_records->rec_tot, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $dbtotal_records->amount_tot;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $dbtotal_records->amount_tot, 1).'% '.JText::_('of all').' '.$text;
		
		return $totals;
	}
}
?>